-- Impor pustaka Android yang diperlukan
require "import"
import "android.widget.Toast"
import "android.icu.util.Calendar"
import "android.icu.util.ULocale"
import "android.icu.text.SimpleDateFormat"
import "android.os.Build"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "com.androlua.LuaDialog"

layout={LinearLayout, orientation="vertical",
{EditText, hint=" masukkan angka di sini", id="edit",}}
dlg=LuaDialog()
dlg.setTitle("Sesuaikan tanggal hijriyah").setMessage("Tambahkan tanda minus di depan angka untuk mengurangi tanggal.\nMasukkan angka saja untuk menambahkan tanggal.\nMasukkan angka 0 untuk default.").setView(loadlayout(layout)).setButton("Ok",function()
if edit.text==""
this.postSpeak(1100," tidak ada input yang dimasukkan")
return true
elseif tonumber(edit.text)==nil
this.postSpeak(1100,"format penulisan salah")
return true
else
ariJoe=package.searchpath("main",package.path):match("(.*)main.lua").."/main.lua"
teks=io.open(ariJoe,"r"):read("*all")
local hasil = teks:gsub("local islamicDate = getIslamicDate%((-?%d+)%)","local islamicDate = getIslamicDate("..edit.text..")")
io.open(ariJoe, "w"):write(hasil):close()
if edit.text:gsub("%d+","7")=="7"
this.postSpeak(1100," tanggal hijriyah telah ditambah sebanyak: "..edit.text.." dari default")
else
this.postSpeak(1100," tanggal hijriyah telah dikurangi sebanyak: "..edit.text.." dari default")
end
dlg=nil
end
end).setButton2("Batal")

-- Fungsi untuk memeriksa apakah versi Android SDK memenuhi persyaratan minimum
function checkAndroidSDK()
local minSdkVersion = 21 --Sesuaikan ini dengan versi SDK minimal yang Anda perlukan
local currentSdkVersion = Build.VERSION.SDK_INT
if currentSdkVersion >= minSdkVersion return true
else print("Versi Android Anda tidak memenuhi persyaratan minimum.")
return false     end end

-- Fungsi untuk mendapatkan tanggal Universal (Gregorian) dengan nama hari di Jawa
function getUniversalDateWithDayName()
    if not checkAndroidSDK() then
        return nil
    end
    
-- Buat instance kalender Gregorian
    local gregorianCalendar = Calendar.getInstance(ULocale("ID"))

-- Format tanggal Universal (Gregorian) dengan nama hari dalam INDONESIA
    local gregorianSdf = SimpleDateFormat("EEEE dd MMMM yyyy", ULocale("ID"))
    local formattedGregorianDate = gregorianSdf.format(gregorianCalendar.getTime())

    return formattedGregorianDate
end

-- Fungsi untuk mendapatkan tanggal Islam (Hijriah) di INDONESIA dengan penyesuaian hari
function getIslamicDate(adjustDays)
    if not checkAndroidSDK() then
        return nil
    end

-- Membuat instance kalender Islam (Hijriah)
    local islamicCalendar = Calendar.getInstance(ULocale("ID@calendar=islamic"))

-- Menambahkan atau mengurangi jumlah hari sesuai dengan adjustDays
islamicCalendar.add(Calendar.DATE, adjustDays)
-- Format tanggal Islam (Hijriah)
    local islamicSdf = SimpleDateFormat("dd MMMM yyyy", ULocale("ID@calendar=islamic"))
    local formattedIslamicDate = islamicSdf.format(islamicCalendar.getTime())

    return formattedIslamicDate
end

-- tampilkan dialog penyesuaian saat fokus pada tombol kembali
if this.check("kembali",node) dlg.show()
return true end

-- Contoh penggunaan  kalender:
local gregorianDateWithDayName = getUniversalDateWithDayName()
local islamicDate = getIslamicDate(-1)

if gregorianDateWithDayName and islamicDate then
    service.speak(gregorianDateWithDayName .. ". Insya Allah bertepatan pada: " .. islamicDate)
else
    print("Sayang sekali gagal menentukan tanggal.")
end